import { Host, h } from "@stencil/core";
import { AriaValidationController } from "../../utils/aria/aria-validation-controller";
import { ElementActivationController } from "../../utils/aria/element-activation-controller";
import { ReactiveControllerHost } from "../../utils/reactive-controller-host";
export class LmvzMenuItem extends ReactiveControllerHost {
    el;
    get validationEl() {
        return this.el;
    }
    validationSlot;
    get role() {
        return 'menuitem';
    }
    get ti() {
        return 0;
    }
    lmvzActivation;
    constructor() {
        super();
        this.addController(new AriaValidationController(this, { validationTiming: 'slot' }));
        this.addController(new ElementActivationController(this));
    }
    render() {
        return (h(Host, { key: '1a37d2873a29c713cf95c60070c8dcf045c9f8fc' }, h("slot", { key: 'c6578bcfdb9f0cebad095d80f0ed63cf663bf91e', ref: (e) => (this.validationSlot = e) })));
    }
    static get is() { return "lmvz-menuitem"; }
    static get encapsulation() { return "scoped"; }
    static get originalStyleUrls() {
        return {
            "$": ["./lmvz-menuitem.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["lmvz-menuitem.css"]
        };
    }
    static get properties() {
        return {
            "role": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "string",
                    "resolved": "string",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": true,
                "setter": false,
                "reflect": true,
                "attribute": "role",
                "defaultValue": "'menuitem'"
            },
            "ti": {
                "type": "number",
                "mutable": false,
                "complexType": {
                    "original": "number",
                    "resolved": "number",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                },
                "getter": true,
                "setter": false,
                "reflect": true,
                "attribute": "tabindex",
                "defaultValue": "0"
            }
        };
    }
    static get events() {
        return [{
                "method": "lmvzActivation",
                "name": "lmvzActivation",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "Event emitted when the menu item is activated, either by a click or by pressing \"Enter\" or \"Space\" while the menu item is focused."
                },
                "complexType": {
                    "original": "void",
                    "resolved": "void",
                    "references": {}
                }
            }];
    }
    static get elementRef() { return "el"; }
}
